/**************************************/
/* P6ŃUihD̃[Uf[^̏ꏊ */
/* ؂o߂̃t@C쐬   */
/**************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define	MAXNAME		16


int main(int argc, char **argv)
{
	FILE	*infp, *outfp1, *outfp2;

	int		i,j,k;
	int		c;
	unsigned char ftmp[MAXNAME];

	int		trackno,secno;
	int		endtrackno,endsecno;

	typedef struct {
		unsigned char fname[MAXNAME];
		int fsecnum;
	} FILE_PR;

	FILE_PR filepr[] = {
		{"PLAYER",0x04},
		{"d.0000",0x1c},
		{"d.0001",0x1c},
		{"d.0002",0x1c},
		{"d.0003",0x1c},
		{"d.0004",0x1c},
		{"d.0005",0x1c},
		{"d.0006",0x1c},
		{"d.0007",0x1c},
		{"d.0008",0x1c},
		{"d.0009",0x1c},
		{""      ,0x00}
	};

	if (argc != 4) {
		fprintf(stderr, "Usage: xanauser listdata outlist1 outlist2\n");
		exit(1);
	}

/* open files */

	if ((infp = fopen(argv[1], "rb")) == NULL) {
		perror(argv[1]);
		exit(1);
	}

	if ((outfp1 = fopen(argv[2], "w")) == NULL) {
		perror(argv[2]);
		exit(1);
	}

	if ((outfp2 = fopen(argv[3], "w")) == NULL) {
		perror(argv[3]);
		exit(1);
	}

	for (k = 0;filepr[k].fsecnum != 0;k ++) {
		for (j = 0;;j += 16) {

			if (fseek(infp, j, SEEK_SET) != 0) {
				fprintf(stderr,"File not found! %s\n", filepr[k].fname);
				exit(1);
			}

			for (i = 0;i < 6;i ++) {
				ftmp[i] = fgetc(infp);
			}
			ftmp[i] = 0;

			if (strcmp(filepr[k].fname, ftmp) == 0) {
				break;
			}
		}

		for (i = 0;i < 6;i ++) {
			fgetc(infp);
		}

		trackno = fgetc(infp);
		secno   = fgetc(infp);

		endsecno = secno + (filepr[k].fsecnum-1) % 16;
		endtrackno = trackno + (filepr[k].fsecnum-1) / 16;
		if (endsecno > 16) {
			endsecno -= 16;
			endtrackno ++;
		}


	// t@C 擪gbNԍ 擪ZN^ԍ IgbNԍ IZN^ԍ
		fprintf(outfp1,"%s %d %d %d %d\n",filepr[k].fname, trackno, secno, endtrackno, endsecno);

	// t@C hCuԍ(=0) 擪gbNԍ 擪ZN^ԍ
		fprintf(outfp2,"%s 0 %d %d\n",filepr[k].fname, trackno, secno);

	}


	fclose(infp);
	fclose(outfp1);
	fclose(outfp2);

	return(0);

}

